## AgsWasapiDevout

AgsWasapiDevout — Output to soundcard

## Stability Level

Stable, unless otherwise indicated

## Functions

#define | AGS_WASAPI_DEVOUT_GET_OBJ_MUTEX()
GQuark | ags_wasapi_devout_error_quark ()
gboolean | ags_wasapi_devout_test_flags ()
void | ags_wasapi_devout_set_flags ()
void | ags_wasapi_devout_unset_flags ()
void | ags_wasapi_devout_switch_buffer_flag ()
void | ags_wasapi_devout_realloc_buffer ()
AgsWasapiDevout * | ags_wasapi_devout_new ()

## Properties

double | bpm | Read / Write
gpointer | buffer | Read
guint | buffer-size | Read / Write
char * | device | Read / Write
guint | dsp-channels | Read / Write
guint | format | Read / Write
guint | pcm-channels | Read / Write
guint | samplerate | Read / Write

## Types and Values

#define | AGS_WASAPI_DEVOUT_DEFAULT_APP_BUFFER_SIZE
#define | AGS_WASAPI_DEVOUT_DEFAULT_WASAPI_BUFFER_SIZE
enum | AgsWasapiDevoutFlags
enum | AgsWasapiDevoutAppBufferMode
#define | AGS_WASAPI_DEVOUT_ERROR
enum | AgsWasapiDevoutError

## Object Hierarchy

        GFlags
        ╰── AgsWasapiDevoutFlags
        GObject
        ╰── AgsWasapiDevout

## Includes

    #include <ags/audio/wasapi/ags_wasapi_devout.h>

## Description

AgsWasapiDevout represents a soundcard and supports output.

## Functions

### AGS_WASAPI_DEVOUT_GET_OBJ_MUTEX()

    #define AGS_WASAPI_DEVOUT_GET_OBJ_MUTEX(obj) (&(((AgsWasapiDevout *) obj)->obj_mutex))

### ags_wasapi_devout_error_quark ()

    GQuark
    ags_wasapi_devout_error_quark ();

### ags_wasapi_devout_test_flags ()

    gboolean
    ags_wasapi_devout_test_flags (AgsWasapiDevout *wasapi_devout,
                                  AgsWasapiDevoutFlags flags);

Test `flags` to be set on `wasapi_devout` .

#### Parameters

wasapi_devout | the AgsWasapiDevout |
flags | the flags |

#### Returns

`TRUE` if flags are set, else `FALSE`

Since: 3.0.0

### ags_wasapi_devout_set_flags ()

    void
    ags_wasapi_devout_set_flags (AgsWasapiDevout *wasapi_devout,
                                 AgsWasapiDevoutFlags flags);

Enable a feature of `wasapi_devout` .

#### Parameters

wasapi_devout | the AgsWasapiDevout |
flags | see AgsWasapiDevoutFlags |

Since: 3.0.0

### ags_wasapi_devout_unset_flags ()

    void
    ags_wasapi_devout_unset_flags (AgsWasapiDevout *wasapi_devout,
                                   AgsWasapiDevoutFlags flags);

Disable a feature of `wasapi_devout` .

#### Parameters

wasapi_devout | the AgsWasapiDevout |
flags | see AgsWasapiDevoutFlags |

Since: 3.0.0

### ags_wasapi_devout_switch_buffer_flag ()

    void
    ags_wasapi_devout_switch_buffer_flag (AgsWasapiDevout *wasapi_devout);

The buffer flag indicates the currently played buffer.

#### Parameters

wasapi_devout | an AgsWasapiDevout |

Since: 3.0.0

### ags_wasapi_devout_realloc_buffer ()

    void
    ags_wasapi_devout_realloc_buffer (AgsWasapiDevout *wasapi_devout);

Reallocate the internal audio buffer.

#### Parameters

wasapi_devout | the AgsWasapiDevout |

Since: 3.0.0

### ags_wasapi_devout_new ()

    AgsWasapiDevout *
    ags_wasapi_devout_new ();

Creates a new instance of AgsWasapiDevout.

#### Returns

a new AgsWasapiDevout

Since: 3.0.0

## Types and Values

### AGS_WASAPI_DEVOUT_DEFAULT_APP_BUFFER_SIZE

    #define AGS_WASAPI_DEVOUT_DEFAULT_APP_BUFFER_SIZE (8)

### AGS_WASAPI_DEVOUT_DEFAULT_WASAPI_BUFFER_SIZE

    #define AGS_WASAPI_DEVOUT_DEFAULT_WASAPI_BUFFER_SIZE (8192)

### enum AgsWasapiDevoutFlags

Enum values to control the behavior or indicate internal state of AgsWasapiDevout by enable/disable as flags.

#### Members

AGS_WASAPI_DEVOUT_INITIALIZED | the soundcard was initialized |
AGS_WASAPI_DEVOUT_START_PLAY | playback starting |
AGS_WASAPI_DEVOUT_PLAY | do playback |
AGS_WASAPI_DEVOUT_SHUTDOWN | stop playback |
AGS_WASAPI_DEVOUT_NONBLOCKING | do non-blocking calls |
AGS_WASAPI_DEVOUT_ATTACK_FIRST | use first attack, instead of second one |
AGS_WASAPI_DEVOUT_SHARE_MODE_EXCLUSIVE | share mode exclusive |

### enum AgsWasapiDevoutAppBufferMode

Enum values to indicate internal state of AgsWasapiDevout application buffer by setting mode.

#### Members

AGS_WASAPI_DEVOUT_APP_BUFFER_0 | ring-buffer 0 |
AGS_WASAPI_DEVOUT_APP_BUFFER_1 | ring-buffer 1 |
AGS_WASAPI_DEVOUT_APP_BUFFER_2 | ring-buffer 2 |
AGS_WASAPI_DEVOUT_APP_BUFFER_3 | ring-buffer 3 |
AGS_WASAPI_DEVOUT_APP_BUFFER_4 | ring-buffer 4 |
AGS_WASAPI_DEVOUT_APP_BUFFER_5 | ring-buffer 5 |
AGS_WASAPI_DEVOUT_APP_BUFFER_6 | ring-buffer 6 |
AGS_WASAPI_DEVOUT_APP_BUFFER_7 | ring-buffer 7 |

### AGS_WASAPI_DEVOUT_ERROR

    #define AGS_WASAPI_DEVOUT_ERROR (ags_wasapi_devout_error_quark())

### enum AgsWasapiDevoutError

#### Members

AGS_WASAPI_DEVOUT_ERROR_LOCKED_SOUNDCARD |  |
AGS_WASAPI_DEVOUT_ERROR_BROKEN_CONFIGURATION |  |

## Property Details

### The `“bpm”` property

      “bpm”                      double

Beats per minute

Owner: AgsWasapiDevout

Flags: Read / Write

Allowed values: [1,240]

Default value: 120

Since: 3.0.0

### The `“buffer”` property

      “buffer”                   gpointer

The buffer

Owner: AgsWasapiDevout

Flags: Read

Since: 3.0.0

### The `“buffer-size”` property

      “buffer-size”              guint

The buffer size

Owner: AgsWasapiDevout

Flags: Read / Write

Allowed values: [1,44100]

Default value: 940

Since: 3.0.0

### The `“device”` property

      “device”                   char *

The core audio soundcard indentifier

Owner: AgsWasapiDevout

Flags: Read / Write

Default value: "ags-wasapi-devout-0"

Since: 3.0.0

### The `“dsp-channels”` property

      “dsp-channels”             guint

The dsp channel count

Owner: AgsWasapiDevout

Flags: Read / Write

Allowed values: [1,64]

Default value: 2

Since: 3.0.0

### The `“format”` property

      “format”                   guint

The precision of the buffer

Owner: AgsWasapiDevout

Flags: Read / Write

Allowed values: [1,64]

Default value: 16

Since: 3.0.0

### The `“pcm-channels”` property

      “pcm-channels”             guint

The pcm channel count

Owner: AgsWasapiDevout

Flags: Read / Write

Allowed values: [1,64]

Default value: 2

Since: 3.0.0

### The `“samplerate”` property

      “samplerate”               guint

The samplerate

Owner: AgsWasapiDevout

Flags: Read / Write

Allowed values: [8000,96000]

Default value: 44100

Since: 3.0.0